/* This segment simulates main() for Windows, creates a window, etc. */
//#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <mmsystem.h>
#include <stdlib.h>
#include <stdarg.h>
#include <conio.h>
#include <commctrl.h>
#include <stdio.h>
#include <string.h>
#include <assert.h>
#include <time.h>
#include <math.h>

#include "resource.h"
#include "glid3d.h"


#define FOG_OFF 0
#define FOG_MODE1 1
#define FOG_MODE2 2

int fogmode = 0;
int blendfix = 1;
int precisionfix = 1;
int fullscreen = 1;
int mipmaps = 0;
int usezinverse = 1;



/* Forward declarations */
HWND hWndMain;
char ** commandLineToArgv(LPSTR lpCmdLine, int *pArgc);

/*
 * MainWndproc
 *
 * Callback for all Windows messages
 */
/*
int qhead = 0;
int qtail = 0;
int queue[256] = {0};
*/
  
BOOL WINAPI MainDlgProc(HWND hdlg, UINT message, UINT wParam, LONG lParam)
/***************************************************************

FUNCTION:   MainDlgProc(hdlg, message, wParam, lParam)

PURPOSE:

   Dialog window procedure. Does nothing much, just shows a dialog.

***************************************************************/
{
	// Unused(lParam);
	int res;
	HWND    hwndTest;
	char	buf[255];
	char   text[100];

	switch (message)
	{

		case WM_INITDIALOG:
			if(fullscreen)
				SendDlgItemMessage(hdlg, IDC_FULLSCREEN, BM_SETCHECK, BST_CHECKED, 0);
			else
				SendDlgItemMessage(hdlg, IDC_FULLSCREEN, BM_SETCHECK, BST_UNCHECKED, 0);
			if(blendfix)
				SendDlgItemMessage(hdlg, IDC_BLENDFIX, BM_SETCHECK, BST_CHECKED, 0);
			else
				SendDlgItemMessage(hdlg, IDC_BLENDFIX, BM_SETCHECK, BST_UNCHECKED, 0);
			if(mipmaps)
				SendDlgItemMessage(hdlg, IDC_MIPMAPS, BM_SETCHECK, BST_CHECKED, 0);
			else
				SendDlgItemMessage(hdlg, IDC_MIPMAPS, BM_SETCHECK, BST_UNCHECKED, 0);
			if(precisionfix)
				SendDlgItemMessage(hdlg, IDC_PRECISION, BM_SETCHECK, BST_CHECKED, 0);
			else
				SendDlgItemMessage(hdlg, IDC_PRECISION, BM_SETCHECK, BST_UNCHECKED, 0);

			if(usezinverse)
				SendDlgItemMessage(hdlg, IDC_ZINVERSE, BM_SETCHECK, BST_CHECKED, 0);
			else
				SendDlgItemMessage(hdlg, IDC_ZINVERSE, BM_SETCHECK, BST_UNCHECKED, 0);

//			SendDlgItemMessage(hdlg, IDC_DEPTHRANGE, TBM_SETRANGE, TRUE, MAKELONG(50,65535));
//
//			SendDlgItemMessage(hdlg, IDC_DEPTHRANGE, TBM_SETPOS, TRUE, zdepthrange);




			switch(fogmode) {
			case 0: SendDlgItemMessage(hdlg, IDC_FOGOFF, BM_SETCHECK, BST_CHECKED, 0); break;
			case 1: SendDlgItemMessage(hdlg, IDC_FOGMODE1, BM_SETCHECK, BST_CHECKED, 0); break;
			case 2: SendDlgItemMessage(hdlg, IDC_FOGMODE2, BM_SETCHECK, BST_CHECKED, 0); break;
			default: SendDlgItemMessage(hdlg, IDC_FOGOFF, BM_SETCHECK, BST_CHECKED, 0); break;
			}
		break;


		case WM_COMMAND:
 			switch (LOWORD(wParam))
			{

				case IDOK:
				case IDCANCEL:
					hwndTest = GetFocus() ;
 

					if(SendDlgItemMessage(hdlg, IDC_MIPMAPS, BM_GETCHECK, 0, 0) ==  BST_CHECKED)
						mipmaps = 1;
					else
						mipmaps = 0;

					if(SendDlgItemMessage(hdlg, IDC_PRECISION, BM_GETCHECK, 0, 0) ==  BST_CHECKED)
						precisionfix = 1;
					else
						precisionfix = 0;

					if(SendDlgItemMessage(hdlg, IDC_BLENDFIX, BM_GETCHECK, 0, 0) ==  BST_CHECKED)
						blendfix = 1;
					else
						blendfix = 0;

					if(SendDlgItemMessage(hdlg, IDC_FULLSCREEN, BM_GETCHECK, 0, 0) ==  BST_CHECKED)
						fullscreen = 1;
					else
						fullscreen = 0;

					if(SendDlgItemMessage(hdlg, IDC_ZINVERSE, BM_GETCHECK, 0, 0) ==  BST_CHECKED)
						usezinverse = 1;
					else
						usezinverse = 0;

//					zdepthrange = (hdlg, IDC_DEPTHRANGE, TBM_GETPOS, 0, 0);

					if(SendDlgItemMessage(hdlg, IDC_FOGOFF, BM_GETCHECK, 0, 0) ==  BST_CHECKED)
						fogmode = 0;
					else
						if(SendDlgItemMessage(hdlg, IDC_FOGMODE1, BM_GETCHECK, 0, 0) ==  BST_CHECKED)
							fogmode = 1;
							else 
							if(SendDlgItemMessage(hdlg, IDC_FOGMODE2, BM_GETCHECK, 0, 0) ==  BST_CHECKED)
								fogmode = 2;
					EndDialog(hdlg, LOWORD(wParam) == IDOK);
					return TRUE;
					break;
				default:
					break;
			}
		break;

		default:
			break;
	}

	return FALSE;
}

static BOOL GoDialog(HINSTANCE hInstance)
{
	DLGPROC lpMainDlg;
	BOOL result;
	result=DialogBox(hInstance, MAKEINTRESOURCE(IDD_DIALOG1), hWndMain, (DLGPROC)MainDlgProc);
	return result;
}



/*
 * WinMain
 */
int PASCAL WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance, 
    LPSTR lpCmdLine, int nCmdShow )
{
//  if( !initApplication(hInstance, nCmdShow) )
  //  return FALSE;
  
  //{
	CHAR pszProfileName[_MAX_PATH];
	CHAR pszSection[32];
	CHAR pszKey[32];
	CHAR pszString[256];
	CHAR pszDevice[256];
	hWndMain = 0;

	lstrcpy(pszProfileName, "");
	GetSystemDirectory(pszProfileName, sizeof(pszProfileName));
	if (pszProfileName[lstrlen(pszProfileName) - 1] != '\\')
		lstrcat(pszProfileName, "\\");
	lstrcat(pszProfileName, GLID3D_PROFILENAME);



	lstrcpy(pszSection,"Misc");

	lstrcpy(pszKey, GLID3DPROF_VIDEO_FOGMODE);
	fogmode = GliD3DGetProfileInt(pszSection, pszKey, 0, pszProfileName);

	lstrcpy(pszKey, GLID3DPROF_VIDEO_FULLSCREEN);
	fullscreen = GliD3DGetProfileInt(pszSection, pszKey, TRUE, pszProfileName);
	lstrcpy(pszKey, GLID3DPROF_VIDEO_BLENDFIX);
	blendfix = GliD3DGetProfileInt(pszSection, pszKey, TRUE, pszProfileName);
	lstrcpy(pszKey, GLID3DPROF_VIDEO_MIPMAPS);
	mipmaps = GliD3DGetProfileInt(pszSection, pszKey, FALSE, pszProfileName);
	lstrcpy(pszKey, GLID3DPROF_VIDEO_PRECISIONFIX);
	precisionfix = GliD3DGetProfileInt(pszSection, pszKey, FALSE, pszProfileName);
	lstrcpy(pszKey, GLID3DPROF_VIDEO_USEZINVERSE);
	usezinverse = GliD3DGetProfileInt(pszSection, pszKey, TRUE, pszProfileName);
//	lstrcpy(pszKey, GLID3DPROF_VIDEO_ZDEPTHRANGE);
//	zdepthrange = GliD3DGetProfileInt(pszSection, pszKey, 20000, pszProfileName);


	if(!GoDialog(hInstance))
	{
//		DestroyWindow(hWndMain);
//		MessageBox(NULL,"Cancelled", NULL, MB_OK);
		return 0;
	}
	// Video info
	lstrcpy(pszSection,"Misc");

	lstrcpy(pszKey, GLID3DPROF_VIDEO_FOGMODE);
	GliD3DWriteProfileInt(pszSection, pszKey, fogmode, pszProfileName);

	lstrcpy(pszKey, GLID3DPROF_VIDEO_FULLSCREEN);
	GliD3DWriteProfileInt(pszSection, pszKey, fullscreen, pszProfileName);
	lstrcpy(pszKey, GLID3DPROF_VIDEO_BLENDFIX);
	GliD3DWriteProfileInt(pszSection, pszKey, blendfix, pszProfileName);
	lstrcpy(pszKey, GLID3DPROF_VIDEO_MIPMAPS);
	GliD3DWriteProfileInt(pszSection, pszKey, mipmaps, pszProfileName);
	lstrcpy(pszKey, GLID3DPROF_VIDEO_PRECISIONFIX);
	GliD3DWriteProfileInt(pszSection, pszKey, precisionfix, pszProfileName);
	lstrcpy(pszKey, GLID3DPROF_VIDEO_USEZINVERSE);
	GliD3DWriteProfileInt(pszSection, pszKey, usezinverse, pszProfileName);
//	lstrcpy(pszKey, GLID3DPROF_VIDEO_ZDEPTHRANGE);
//	GliD3DWriteProfileInt(pszSection, pszKey, zdepthrange, pszProfileName);

//	DestroyWindow(hWndMain);
  return 0;
  
} /* WinMain */

